/** 
 *  Barre d'tat:
 *  Elle permet d'afficher un certain nombre d'informations concernant un MNT:
 *   -les coordonnes courantes
 *   -l'altitude courante
 *   
 * 
 * @author HEIT Sylvestre & Coustillac Laurent
 *
 *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;


import javax.swing .*;
import java.awt.event.*;
import java.awt.Dimension;
import java.awt.*;
import javax.swing.border.*;
import kartoMNT.karto.math.*;
import java.awt.geom.*;
import java.text.*;

/** Barre d'tat du MNT:
  * Affiche les coordonnes courantes et l'altitude
  */
public class BarreEtatMNT extends JPanel implements SelectDocumentListener,MouseMotionListener/*,ColorListener*/
    {
        BarreEtatMNT(DocumentMNTContainer w)
        {
            JLabel labelesp;
            format=new DecimalFormat("#.#");

            documentMNTContainer=w;
            //documentMNTContainer.addSelectDocumentKartoListener(this);
            currentpanel=null;
            if(documentMNTContainer!=null)
                documentSelected(documentMNTContainer.getCurrentDocumentMNT());

            setBorder(new EmptyBorder(2,0,0,0));

            GridBagLayout gridbag;
            setLayout(gridbag=new GridBagLayout());
            GridBagConstraints constraint = new GridBagConstraints();


            border=new ReliefBorder(ReliefBorder.LOWERED);


            labelespfin=new JLabel();
            labelespfin.setBorder(border);

            constraint.weightx=0;
            constraint.fill=GridBagConstraints.VERTICAL;

            constraint.insets=new Insets(0,0,0,0);
            labelc=new JLabel("xxxxxx");
            Dimension d=labelc.getPreferredSize();
            gridbag.setConstraints(labelc, constraint);
            labelc.setBorder(border);
            labelc.setPreferredSize(new Dimension(100,(int)d.getHeight()) );
            labelc.setText("");
            add(labelc);

            constraint.insets=new Insets(0,2,0,0);

            labelc2=new JLabel();
            gridbag.setConstraints(labelc, constraint);
            labelc2.setBorder(border);
            labelc2.setPreferredSize(new Dimension(110,(int)d.getHeight()) );
            labelc2.setText("");
            add(labelc2);

            // altitude
            labelCurrentAltitude=new JLabel();
            labelCurrentAltitude.setBorder(border);
            labelCurrentAltitude.setPreferredSize(new Dimension(70,(int)d.getHeight()));
            labelCurrentAltitude.setText("");
            gridbag.setConstraints(labelCurrentAltitude, constraint);
            add(labelCurrentAltitude);

            constraint.weightx=1;
            constraint.fill=GridBagConstraints.BOTH;
            gridbag.setConstraints(labelespfin, constraint);
            add(labelespfin);

        }

        public void setMessage(String message)
        {
            labelespfin.setText(message);
        }


        private JLabel createEpace(int x,int y)
        {
            JLabel labelesp=new JLabel();
            labelesp.setBorder(border);
            labelesp.setPreferredSize(new Dimension(x,y) );
            return labelesp;
        }


        public void documentSelected(Document doc)
        {
            if(currentpanel!=null)
                currentpanel.removeMouseMotionListener(this);
            //necessaire car sinon le canvas reste indefiniment en mmoire
            if(doc==null)
                {
                    currentpanel=null;
                }
            else
                {
                    currentpanel=((DocumentMNT)doc).getFloatDataViewer();
                }
            if(currentpanel!=null)
                currentpanel.addMouseMotionListener(this);
        }


        public void mouseMoved(MouseEvent e)
        {
            if(documentMNTContainer==null)
                return;
            DocumentMNT doc=documentMNTContainer.getCurrentDocumentMNT();
            if(doc==null)
                return;
            MNT mnt=doc.getMNT();
            if(mnt==null)
                return;


            Point coord=new Point();
            double scalex=doc.getFloatDataViewer().getScaleX();
            double scaley=doc.getFloatDataViewer().getScaleY();
            int x=(int)(e.getX()/scalex);
            int y=(int)(e.getY()/scaley);
            labelc.setText(" x="+x+"  y="+y);
            labelc2.setText(" X="+format.format(x*mnt.getPasX ()+mnt.getX1())+"  Y="+format.format(y*mnt.getPasY ()+mnt.getY1()));

            FloatDataViewer ldnp=doc.getFloatDataViewer();
            FloatData ldn=doc.getFloatData();
            if((ldn!=null)&&(ldnp!=null))
                {
                    x=(int)ldnp.canvas2ObjX(e.getX());
                    y=(int)ldnp.canvas2ObjY(e.getY());
                    //Dimension dim=ldnp.getSize();
                    if((x<ldn.getXMax())&&(y<ldn.getYMax()))
                        {
                            float altitude=ldn.getValue(x,y);
                            labelCurrentAltitude.setText(""+format.format(altitude)+"m");
                        }
                    else
                        labelCurrentAltitude.setText("");
                }

        }

        public void mouseDragged(MouseEvent e)
        {
            mouseMoved(e);
        }


        JPanel separator()
        {
            JPanel Separator=new JPanel();
            Separator.setBorder(new EmptyBorder(0,0,0,0));
            Separator.setPreferredSize(new Dimension(2,1) );
            return Separator;
        }


        JLabel labelespfin;
        protected DocumentMNTContainer documentMNTContainer;
        protected JPanel currentpanel;
        JLabel labelc,labelc2;
        JLabel labelCurrentAltitude;

        //JPanel rightpanel,leftpanel;
        Border border;
        DecimalFormat format;
    }

