/** 
 * Brush:
 * Contient la liste des coordonnes des points du pinceau
 * Permet de gnrer un Pinceau circulaire
 *   
 * 
 * @author HEIT Sylvestre & Coustillac Laurent
 *
 *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;

class Brush
    {
    	
    	protected int epaisseur;
        public float altitude;
        
        public int[] pinceauContourX,pinceauContourY; //liste des coordonnes des points contour du pinceau

        public int[] pinceauX,pinceauY;        //liste des coordonnes des points du pinceau
        private int maxx,minx,maxy,miny;

        
        Brush()
        {
            setEpaisseur(1);
            altitude=LignesDeNiveaux.LINE_WITH_NO_ALTITUDE;
        }

        
        /*
         * retourne l'abscisse maximale du pinceau
         */
        public int getXmax()
        {
            return maxx;
        }

        /*
         * retourne l'ordonnee maximale du pinceau
         */
        public int getYmax()
        {
            return maxy;
        }

        /*
         * retourne l'abscisse minimale du pinceau
         */
        public int getXmin()
        {
            return minx;
        }

        /*
         * retourne l'ordonnee maximale du pinceau
         */
        public int getYmin()
        {
            return miny;
        }

        


        public int getEpaisseur()
        {
            return epaisseur;
        }

        public void setEpaisseur(int e)
        {
            epaisseur=e;

            int R=e/2+1;
            int R2=e*e;
            int l=2*R+1;
            int[] tab=new int[l*l];
            int[] tab2=new int[l*l];
            int x,y,offset;
            int m=0;
            for(y=0;y<l;y++)
                {
                    for(x=0;x<l;x++)
                        {
                            if( 4*((x-R)*(x-R)+(y-R)*(y-R)) <=R2)
                                {
                                    tab[x+y*l]=1;
                                    m++;
                                }
                            else
                                {
                                    tab[x+y*l]=0;
                                }
                            tab2[x+y*l]=tab[x+y*l];
                        }
                }

            for(y=1;y<l-1;y++)
                {
                    for(x=1;x<l-1;x++)
                        {
                            if( (tab[(x+1)+y*l]==1)&&
                                    (tab[(x-1)+y*l]==1)&&
                                    (tab[x+(y-1)*l]==1)&&
                                    (tab[x+(y+1)*l]==1)&&
                                    (tab[(x-1)+(y-1)*l]==1)&&
                                    (tab[(x+1)+(y-1)*l]==1)&&
                                    (tab[(x-1)+(y+1)*l]==1)&&
                                    (tab[(x+1)+(y+1)*l]==1)
                              )
                                {
                                    tab2[x+y*l]=0;
                                }
                        }
                }
            offset=0;
            int n=0;
            for(y=0;y<l;y++)
                {
                    for(x=0;x<l;x++)
                        {
                            if(tab2[offset]==1)
                                {
                                    n++;
                                }
                            offset++;
                        }
                }

            pinceauContourX=new int[n];
            pinceauContourY=new int[n];
            pinceauX=new int[m];
            pinceauY=new int[m];


            offset=0;
            int i=0;
            int j=0;
            for(y=0;y<l;y++)
                {
                    for(x=0;x<l;x++)
                        {
                            if(tab2[offset]==1)
                                {
                                    pinceauContourX[i]=x-R;
                                    pinceauContourY[i]=y-R;
                                    i++;
                                }
                            if(tab[offset]==1)
                                {
                                    pinceauX[j]=x-R;
                                    pinceauY[j]=y-R;
                                    j++;
                                }
                            offset++;
                        }
                }

            maxx=0;
            maxx=0;
            maxy=0;
            maxy=0;
            for(i=1;i<pinceauContourX.length;i++)
                {
                    minx=Math.min(minx,pinceauContourX[i]);
                    maxx=Math.max(maxx,pinceauContourX[i]);
                    miny=Math.min(miny,pinceauContourY[i]);
                    maxy=Math.max(maxy,pinceauContourY[i]);
                }
        }

    }
