/** 
 * CalibrationDialog2:
 * Panel de dialogue permettant d'ajouter, de modifier et de supprimer des points de calibration
 *   
 * 
 * @author HEIT Sylvestre & Coustillac Laurent
 *
 *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;


import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.text.*;
import javax.swing.border.*;

import kartoMNT.karto.outils.*;


public class CalibrationDialog2 extends DocumentPanel implements PointCalibrationSetListener,PointCalibrationListener
{

	/** Creates new form calibrationDialog */
	private void init()
	{
		listModel=new DefaultListModel();
		initComponents();
		jButton5.setEnabled(false);
		jButton6.setEnabled(false);
		jButton3.setEnabled(false);
		jButton4.setEnabled(false);
		//setTitle("Points de calibration");
		format=new DecimalFormat("#.##");
	}


	public CalibrationDialog2(/*java.awt.Frame parent, boolean modal*/)
	{
		//super(parent, modal);
		orientation=HORIZONTAL;
		floating=true;
		init();
	}

	public CalibrationDialog2(boolean _floating,int _orientation)
	{
		//super(parent, modal);
		orientation=_orientation;
		floating=_floating;
		init();
	}

	public static final int HORIZONTAL=1;
	public static final int VERTICAL=2;
	private int orientation;
	/** This method is called from within the constructor to
	 * initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is
	 * always regenerated by the Form Editor.
	 */
	private void initComponents()
	{//GEN-BEGIN:initComponents
		jPanel1 = new javax.swing.JPanel();
		jScrollPane3 = new javax.swing.JScrollPane();
		jList2 = new javax.swing.JList(listModel);
		jPanel3 = new javax.swing.JPanel();
		jButton3 = new javax.swing.JButton();
		jButton4 = new javax.swing.JButton();
		jPanel5 = new javax.swing.JPanel();
		jPanel2 = new javax.swing.JPanel();
		jLabel1 = new javax.swing.JLabel();
		jLabel2 = new javax.swing.JLabel();
		jLabel3 = new javax.swing.JLabel();
		jTextField1 = new javax.swing.JTextField();
		jTextField2 = new javax.swing.JTextField();
		jLabel4 = new javax.swing.JLabel();
		jLabel8 = new javax.swing.JLabel();
		jLabel10 = new javax.swing.JLabel();
		jLabel11 = new javax.swing.JLabel();
		jTextField6 = new javax.swing.JTextField();
		jTextField7 = new javax.swing.JTextField();
		jPanel6 = new javax.swing.JPanel();
		jButton5 = new javax.swing.JButton();
		jButton6 = new javax.swing.JButton();

		if(orientation==VERTICAL)
			/*getContentPane().*/
			setLayout(new java.awt.GridLayout(0, 1));
		else
			/*getContentPane().*/
			setLayout(new java.awt.GridLayout(1, 0));

		/*addWindowListener(new java.awt.event.WindowAdapter()
						  {
							  public void windowClosing(java.awt.event.WindowEvent evt)
							  {
								  closeDialog(evt);
							  }
						  }
						 );*/

		jPanel1.setLayout(new java.awt.BorderLayout());


		if(floating)
			jPanel1.setBorder(new javax.swing.border.TitledBorder(ResourceManager.get("calibPoints")));
		//jScrollPane3.setPreferredSize(new java.awt.Dimension(60, 90));
		jList2.addListSelectionListener(new javax.swing.event.ListSelectionListener()
										{
											public void valueChanged(javax.swing.event.ListSelectionEvent evt)
											{
												ListPointsValueChanged(evt);
											}
										}
									   );

		jScrollPane3.setPreferredSize(new java.awt.Dimension(160, 100));
		jScrollPane3.setViewportView(jList2);

		jLabel3.setText(ResourceManager.get("coordsLabel"));
		jPanel1.add(jLabel3, java.awt.BorderLayout.NORTH);
		jPanel1.add(jScrollPane3, java.awt.BorderLayout.CENTER);

		jPanel3.setLayout(new java.awt.GridBagLayout());
		java.awt.GridBagConstraints gridBagConstraints2;

		jPanel3.setMinimumSize(new java.awt.Dimension(0, 0));
		//jPanel3.setPreferredSize(new java.awt.Dimension(0, 40));
		jButton3.setText(ResourceManager.get("add"));
		jButton3.setToolTipText(ResourceManager.get("addPtTip"));
		jButton3.addActionListener(new java.awt.event.ActionListener()
								   {
									   public void actionPerformed(java.awt.event.ActionEvent evt)
									   {
										   actionAjouter(evt);
									   }
								   }
								  );

		gridBagConstraints2 = new java.awt.GridBagConstraints();
		//gridBagConstraints2.insets = new java.awt.Insets(0, 0, 0, 3);
		gridBagConstraints2.insets = new java.awt.Insets(2, 2, 2, 2);
		jPanel3.add(jButton3, gridBagConstraints2);

		jButton4.setText(ResourceManager.get("suppr"));
		jButton4.setToolTipText(ResourceManager.get("supprPtTip"));
		jButton4.addActionListener(new java.awt.event.ActionListener()
								   {
									   public void actionPerformed(java.awt.event.ActionEvent evt)
									   {
										   actionSupprimer(evt);
									   }
								   }
								  );

		//gridBagConstraints2 = new java.awt.GridBagConstraints();
		//gridBagConstraints2.insets = new java.awt.Insets(0, 3, 0, 0);
		gridBagConstraints2.gridwidth = GridBagConstraints.REMAINDER;
		jPanel3.add(jButton4, gridBagConstraints2);

		jButton6.setText(ResourceManager.get("calib"));
		jButton6.setToolTipText(ResourceManager.get("calibTip"));
		jButton6.addActionListener(new java.awt.event.ActionListener()
								   {
									   public void actionPerformed(java.awt.event.ActionEvent evt)
									   {
										   actionCalibrer(evt);
									   }
								   }
								  );


		jPanel3.add(jButton6, gridBagConstraints2);

		jPanel1.add(jPanel3, java.awt.BorderLayout.SOUTH);

		/*getContentPane().*/
		add(jPanel1);

		jPanel5.setLayout(new java.awt.BorderLayout());

		if(floating)
			jPanel5.setBorder(new javax.swing.border.TitledBorder(ResourceManager.get("edit")));
		else
			jPanel5.setBorder(new EmptyBorder(6,0,0,0));
		jPanel2.setLayout(new kartoMNT.org.netbeans.lib.awtextra.AbsoluteLayout());

		//jLabel1.setFont(new java.awt.Font("Dialog", 0, 12));
		jLabel1.setText(ResourceManager.get("coordTerr"));
		jPanel2.add(jLabel1, new kartoMNT.org.netbeans.lib.awtextra.AbsoluteConstraints(10, 60, -1, -1));

		jLabel2.setText("x=");
		jPanel2.add(jLabel2, new kartoMNT.org.netbeans.lib.awtextra.AbsoluteConstraints(10, 80, -1, -1));

		jTextField1.setText("0");
		jPanel2.add(jTextField1, new kartoMNT.org.netbeans.lib.awtextra.AbsoluteConstraints(30, 80, 50, -1));

		jTextField2.setText("0");
		jPanel2.add(jTextField2, new kartoMNT.org.netbeans.lib.awtextra.AbsoluteConstraints(110, 80, 50, -1));

		jLabel4.setText("y=");
		jPanel2.add(jLabel4, new kartoMNT.org.netbeans.lib.awtextra.AbsoluteConstraints(90, 80, -1, -1));

		//jLabel8.setFont(new java.awt.Font("Dialog", 0, 12));
		jLabel8.setText(ResourceManager.get("coordCart"));
		jPanel2.add(jLabel8, new kartoMNT.org.netbeans.lib.awtextra.AbsoluteConstraints(10, 0, -1, -1));

		jLabel10.setText("x=");
		jPanel2.add(jLabel10, new kartoMNT.org.netbeans.lib.awtextra.AbsoluteConstraints(10, 20, -1, -1));

		jLabel11.setText("y=");
		jPanel2.add(jLabel11, new kartoMNT.org.netbeans.lib.awtextra.AbsoluteConstraints(90, 20, -1, -1));

		jTextField6.setText("0");
		jPanel2.add(jTextField6, new kartoMNT.org.netbeans.lib.awtextra.AbsoluteConstraints(30, 20, 50, -1));

		jTextField7.setText("0");
		jPanel2.add(jTextField7, new kartoMNT.org.netbeans.lib.awtextra.AbsoluteConstraints(110, 20, 50, -1));

		jPanel5.add(jPanel2, java.awt.BorderLayout.CENTER);

		jPanel6.setLayout(new java.awt.GridBagLayout());
		java.awt.GridBagConstraints gridBagConstraints3;

		//jPanel6.setPreferredSize(new java.awt.Dimension(74, 40));
		jButton5.setText(ResourceManager.get("OkKey"));
		jButton5.setToolTipText(ResourceManager.get("majPtTip"));
		jButton5.addActionListener(new java.awt.event.ActionListener()
								   {
									   public void actionPerformed(java.awt.event.ActionEvent evt)
									   {
										   actionUpdate(evt);
									   }
								   }
								  );

		gridBagConstraints3 = new java.awt.GridBagConstraints();
		//jPanel6.add(jButton5, gridBagConstraints3);
		jPanel2.add(jButton5, new kartoMNT.org.netbeans.lib.awtextra.AbsoluteConstraints(10, 115, -1, -1));

		jPanel5.add(jPanel6, java.awt.BorderLayout.SOUTH);


		/*getContentPane().*/
		add(jPanel5);

		//pack();
	}


	private void updateSelection()
	{
		if(selected!=null)
			{
				jTextField6.setText(""+selected.getImageX());
				jTextField7.setText(""+selected.getImageY());

				jTextField1.setText(""+selected.getX());
				jTextField2.setText(""+selected.getY());

				jButton4.setEnabled(true);
				jButton5.setEnabled(true);
				selected.select();
			}
		else
			{
				jTextField1.setText("");
				jTextField2.setText("");
				jTextField6.setText("");
				jTextField7.setText("");
				jButton4.setEnabled(false);
				jButton5.setEnabled(false);
			}

	}

	private void ListPointsValueChanged(javax.swing.event.ListSelectionEvent evt)
	{
		ListElem e=(ListElem)jList2.getSelectedValue();
		if(e==null)
			{
				selected=null;
			}
		else
			{
				selected=e.point;
			}
		updateSelection();

	}




	private void actionSupprimer(java.awt.event.ActionEvent evt)
	{

		//ListElem[] v=(ListElem[])jList2.getSelectedValues();
		Object[] v=(Object[])jList2.getSelectedValues();
		int i;
		for(i=0;i<v.length;i++)
			{
				pointCalibrationSet.remove(((ListElem)v[i]).point);
			}

	}

	private void actionAjouter(java.awt.event.ActionEvent evt)
	{
		PointCalibrationModel p=new PointCalibrationModel();
		p.setImageCoords(10,10);
		if(pointCalibrationSet!=null)
			pointCalibrationSet.add(p);
	}

	private void actionCalibrer(java.awt.event.ActionEvent evt)
	{
		if(documentKarto!=null){
			documentKarto.calibrer();
		}else {
			MsgInfo msg=new MsgInfo(frame,MsgInfo.INFO,MsgInfo.OK,ResourceManager.get("EnregCarteAvCalib"));
		}
	}


	private void actionUpdate(java.awt.event.ActionEvent evt)
	{
		if(selected!=null)
			{
				try
					{
						selected.setImageCoords(Double.parseDouble(jTextField6.getText()),Double.parseDouble(jTextField7.getText()));
						selected.setCoords(Double.parseDouble(jTextField1.getText()),Double.parseDouble(jTextField2.getText()));
					}
				catch(NumberFormatException ne)
					{
						MsgInfo msg=new MsgInfo(frame,MsgInfo.ERROR,MsgInfo.OK,ResourceManager.get("fillError"));
					}
			}
	}



	public void documentSelected(Document doc)
	{
		documentKarto=(DocumentKarto)doc;

		jButton3.setEnabled(doc!=null);
		jButton6.setEnabled(doc!=null);

		if(pointCalibrationSet!=null)
			{
				pointCalibrationSet.removeSetListener(this);
				pointCalibrationSet=null;
			}
		if(documentKarto!=null)
			{
				pointCalibrationSet=documentKarto.getPointCalibrationSet();
				//pointCalibrationSelected(pointCalibrationSet.getSelected());
				pointCalibrationSet.addSetListener(this);
			}

		clear();
		fillList();
	}


	public void fillList()
	{
		if(pointCalibrationSet==null)
			{
				clear();
				return;
			}
		ListElem elem;
		ListIterator it=pointCalibrationSet.listIterator();
		while(it.hasNext())
			{
				elem=new ListElem();
				elem.point=(PointCalibrationModel)it.next();
				elem.point.addListener(this);
				listModel.addElement(elem);
			}
	}

	public void clear()
	{
		int i;

		ListElem elem;
		selected=null;
		for(i=0;i<listModel.size();i++)
			{
				elem=(ListElem)listModel.get(i);
				elem.point.removeListener(this);
				//listModel.removeElementAt(i);
			}
		listModel.clear();

	}

	public void pointCalibrationAdded(PointCalibrationModel p)
	{
		ListElem elem=new ListElem();
		if(p!=null)
			{
				elem.point=p;
				listModel.addElement(elem);
				elem.point.addListener(this);

				jList2.setSelectedValue(elem, true);
			}

	}


	public void pointCalibrationChanged(PointCalibrationModel p)
	{
		jList2.repaint();
	}

	public void pointCalibrationSelected(boolean b)
	{}


	public void pointCalibrationRemoved(PointCalibrationModel p)
	{
		if(p!=null)
			{
				ListElem elem;
				int i;
				for(i=0;i<listModel.size();i++)
					{
						elem=(ListElem)listModel.get(i);
						if(elem.point==p)
							{
								if( elem.point==selected )
									{
										selected=null;
										updateSelection();
									}

								elem.point.removeListener(this);
								listModel.removeElementAt(i);
							}
					}

			}
	}

	/**
	* @param args the command line arguments
	*/
	/*public static void main(String args[])
	{
		new CalibrationDialog2(new javax.swing.JFrame(), true).show();
}*/


	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JPanel jPanel1;
	private javax.swing.JScrollPane jScrollPane3;
	private javax.swing.JList jList2;
	private javax.swing.JPanel jPanel3;
	private javax.swing.JButton jButton3;
	private javax.swing.JButton jButton4;
	private javax.swing.JPanel jPanel5;
	private javax.swing.JPanel jPanel2;
	private javax.swing.JLabel jLabel1;
	private javax.swing.JLabel jLabel2;
	private javax.swing.JLabel jLabel3;
	private javax.swing.JTextField jTextField1;
	private javax.swing.JTextField jTextField2;
	private javax.swing.JLabel jLabel4;
	private javax.swing.JLabel jLabel8;
	private javax.swing.JLabel jLabel10;
	private javax.swing.JLabel jLabel11;
	private javax.swing.JTextField jTextField6;
	private javax.swing.JTextField jTextField7;
	private javax.swing.JPanel jPanel6;
	private javax.swing.JButton jButton5;
	private javax.swing.JButton jButton6;

	private DefaultListModel listModel;
	// End of variables declaration//GEN-END:variables

	class ListElem
		{
			PointCalibrationModel point;

			public String toString()
			{

				return ""+format.format(point.getImageX())+","+format.format(point.getImageY())+"	  "
					   +format.format(point.getX())+","+format.format(point.getY());
			}
		};

	protected DocumentKarto documentKarto;
	protected PointCalibrationSet pointCalibrationSet;
	protected PointCalibrationModel selected;
	boolean floating;
	DecimalFormat format;

}

