/** 
 * Extension de AbstractAction2 permettant de faire en sorte que le bouton ou l'item soit
 * gris si le document courant est gal  NULL
 * 
 * @author HEIT Sylvestre & Coustillac Laurent
 *
 *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;



public abstract class DocumentMNTAction extends AbstractAction2 implements SelectDocumentListener
    {
        DocumentMNTAction(DocumentMNTContainer w)
        {
            super();
            documentMNTContainer=w;
            documentMNTContainer.addSelectDocumentMNTListener(this);
            _documentSelected(getCurrentDocument());
        }

        DocumentMNTAction(DocumentMNTContainer w,String name)
        {
            super(name);
            documentMNTContainer=w;
            documentMNTContainer.addSelectDocumentMNTListener(this);
            _documentSelected(getCurrentDocument());
        }

        DocumentMNTAction(DocumentMNTContainer w,String name, Icon icon)
        {
            super(name,icon);
            documentMNTContainer=w;
            documentMNTContainer.addSelectDocumentMNTListener(this);
            _documentSelected(getCurrentDocument());
        }


        private void _documentSelected(Document doc)
        {
            if(doc==null)
                {
                    setEnabled(false);
                    return;
                }
            setEnabled(true);
        }

        public void documentSelected(Document doc)
        {
            _documentSelected(doc);
        }

        public DocumentMNT getCurrentDocument()
        {
            return documentMNTContainer.getCurrentDocumentMNT();
        }

        protected DocumentMNTContainer documentMNTContainer;
    }


