/** 
 * Slider permettant de positionner sur une rgle plusieurs marques
 *
 * @author HEIT Sylvestre & Coustillac Laurent
 *
 *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;

import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.text.*;
import javax.swing.event.*;



public class MultiSlider extends JPanel implements MouseListener,MouseMotionListener,ComponentListener
    {
        public MultiSlider()
        {

            UIDefaults def = UIManager.getDefaults();
            Object o=def.get("Label.font");
            if(o instanceof Font)
                {
                    font=(Font)o;
                }
            else
                font=(GraphicsEnvironment.getLocalGraphicsEnvironment().getAllFonts())[0];
            format=new DecimalFormat("#.#");

            JLabel label=new JLabel("0,123.456.789");
            Dimension dim=label.getPreferredSize();
            labelsHeight=dim.height;


            markers=new Vector();
            listeners=new Vector();
            changeEvent=new ChangeEvent(this);
            setSorted(true);
            setGradutationHeight(3,3,6);
            spaceLeft=0;
            spaceRight=0;
            xp=new int[5];
            yp=new int[5];

            xp[0]=0;
            yp[0]=0;
            xp[1]=-4;
            yp[1]=4;
            xp[2]=-4;
            yp[2]=11;
            xp[3]=4;
            yp[3]=11;
            xp[4]=4;
            yp[4]=4;
            setPreferredSize(new Dimension(100,yp[2]+2+gradHeight3+labelsHeight ));
            setMinimumSize(new Dimension(1,yp[2]+2+gradHeight3+labelsHeight ));

            selected=-1;
            highlight=-1;
            addMouseListener(this);
            addMouseMotionListener(this);
            addComponentListener(this);
            setLayout(null);

            c=getBackground();
            c1=new Color(Math.min((int)(c.getRed()  *mul),255),
                         Math.min((int)(c.getGreen()*mul),255),
                         Math.min((int)(c.getBlue() *mul),255) );
            int r,g,b;
            r=(int)(c.getRed()*mul2);
            if (r>255) r=255;
            g=(int)(c.getGreen()*mul2);
            if (g>255) g=255;
            b=(int)(c.getBlue()*mul2);
            if (b>255) b=255;
            c2=new Color(r,g,b);
            r=(int)(c.getRed()*mul3);
            if (r>255) r=255;
            g=(int)(c.getGreen()*mul3);
            if (g>255) g=255;
            b=(int)(c.getBlue()*mul3);
            if (b>255) b=255;
            c3=new Color(r,g,b);

            min=0.0;
            max=1.0;
            deltay1=0;
            deltay2=0;

            RemoveWhenDragOut=true;


        }

        public static final double mul=1.2;   //couleurs parties eclairees
        public static final double mul3=1.12; //couleur utilise quan la souris passe au dessus d'une marque
        public static final double mul2=0.66; //couleur des ombres


        void addMultiSliderListener(MultiSliderListener l)
        {
            listeners.add(l);
        }

        void removeMultiSliderListener(MultiSliderListener l)
        {
            listeners.remove(l);
        }

        void clearListener(MultiSliderListener l)
        {
            listeners.clear();
        }

        protected void notifyMarkerAdded(int i)
        {
            ListIterator it=listeners.listIterator();
            while(it.hasNext())
                {
                    ((MultiSliderListener)it.next()).markerAdded(this,i);
                }
        }


        protected void notifyMarkerRemoved(int i)
        {
            ListIterator it=listeners.listIterator();
            while(it.hasNext())
                {
                    ((MultiSliderListener)it.next()).markerRemoved(this,i);
                }
        }

        protected void notifyMarkerMoved(int i)
        {
            ListIterator it=listeners.listIterator();
            while(it.hasNext())
                {
                    ((MultiSliderListener)it.next()).markerMoved(this,i);
                }
        }

        protected void notifyBeginMarkerMove(int i)
        {
            ListIterator it=listeners.listIterator();
            while(it.hasNext())
                {
                    ((MultiSliderListener)it.next()).markerBeginMove(this,i);
                }
        }

        protected void notifyEndMarkerMove(int i)
        {
            ListIterator it=listeners.listIterator();
            while(it.hasNext())
                {
                    ((MultiSliderListener)it.next()).markerEndMove(this,i);
                }
        }

        public void removeWhenDragOut(boolean b)
        {
            RemoveWhenDragOut=b;
        }

        public void setSorted(boolean b)
        {
            marksSorted=b;
            if(marksSorted)
                {
                    Collections.sort(markers);
                }
        }

        public double getMarkerPosition(int i)
        {
            return ((Double)markers.elementAt(i)).doubleValue();
        }

        public void addMarker(double pos)
        {
            Double d;
            markers.add(d=new Double(pos));
            if(marksSorted)
                {
                    Collections.sort(markers);
                }
            int i=markers.indexOf(d);

            notifyMarkerAdded(i);
            repaint();
        }

        public void removeMarker(int i)
        {
            markers.remove(i) ;
            notifyMarkerRemoved(i);
            repaint();
        }

        public void removeAllMarker()
        {
            while(markers.size()>0)
                {
                    markers.remove(0) ;
                    notifyMarkerRemoved(0);
                }
            repaint();
        }


        public void moveMarker(int i,double v)
        {
            /*markers.setElementAt(new Double(v),i);
             notifyMarkerMoved(i);

            if(marksSorted)
                    {boolean tri=false;
                    if(i>0)
                        {if( v< ((Double)markers.elementAt(i-1)).doubleValue() )
                            {tri=true;}
                        //v=Math.max(v,((Double)markers.elementAt(i-1)).doubleValue());
                        }
                    if(selected<markers.size()-1)
                        {if( v> ((Double)markers.elementAt(i+1)).doubleValue() )
                            {tri=true;}
                        //v=Math.min(v,((Double)markers.elementAt(i+1)).doubleValue());
                        }
                    if(tri) Collections.sort(markers);
                    }*/

            if(marksSorted)
                {
                    if(i>0)
                        {
                            v=Math.max(v,((Double)markers.elementAt(i-1)).doubleValue());
                        }
                    if(selected<markers.size()-1)
                        {
                            v=Math.min(v,((Double)markers.elementAt(i+1)).doubleValue());
                        }
                }

            markers.setElementAt(new Double(v),i);
            notifyMarkerMoved(i);

            repaint();
        }

        public void setInterval(double x1,double x2,boolean rescale)
        {
            if(x2<=x1)
                return;

            ListIterator it=markers.listIterator();

            double v;
            int i,r=0;
            while(it.hasNext())
                {
                    if(rescale)
                        {
                            v= ( ((Double)it.next()).doubleValue()-min)/(max-min)*(x2-x1)+x1;
                        }
                    else
                        {
                            v=((Double)it.next()).doubleValue();
                        }
                    if(v<x1)
                        v=x1;
                    if(v>x2)
                        v=x2;
                    it.set(new Double( v ));

                }

            if(rescale)
                {
                    for(i=0;i<markers.size();i++)
                        {
                            notifyBeginMarkerMove(i);
                            notifyMarkerMoved(i);
                            notifyEndMarkerMove(i);
                        }
                }
            min=x1;
            max=x2;

            componentResized(null);
            repaint();
        }

        public void setGradutationHeight(int g1,int g2,int g3)
        {
            gradHeight1=g1;
            gradHeight2=g2;
            gradHeight3=g3;
        }

        public void paint(Graphics graphics)
        {
            super.paint(graphics);
            Graphics2D g=(Graphics2D)graphics;

            g.setColor(c) ;
            g.fillRect(0,labelsHeight, width, height-labelsHeight);

            Rectangle rect;
            String s;

            double n=Math.ceil( Math.log( 2.0*(max-min)/(width-spaceLeft-spaceRight-1) )/Math.log(10.0) );
            double delta=Math.pow(10.0,n);
            double xmin=Math.floor(min/delta)*delta;
            double xmax=Math.ceil(max/delta)*delta;

            double x;
            int xi;
            g.setColor(Color.black);
            int m=(int)Math.round( xmin/delta );
            m= ((m%10)+10)%10;
            for(x=xmin;x<=xmax+delta/10;x+=delta)
                {
                    xi=(int)Math.round(val2ScreenCoords(x));

                    if( m ==0)
                        {
                            s=format.format(x);

                            rect=font.getStringBounds(s, g.getFontRenderContext()).getBounds();

                            deltay1=labelsHeight+1;
                            deltay2=labelsHeight+1+gradHeight3;
                            g.drawLine(xi, deltay1+gradHeight3-1, xi, deltay1+0);
                        }
                    else if( m ==5)
                        {
                            g.drawLine(xi,deltay1+ gradHeight3-1, xi, deltay1+gradHeight3-1-(gradHeight2-1));
                        }
                    else
                        {
                            g.drawLine(xi, deltay1+gradHeight3-1, xi, deltay1+gradHeight3-1-(gradHeight1-1));
                        }
                    m++;
                    m=m%10;
                }


            int[] xPoints=new int[xp.length];
            int[] yPoints=new int[yp.length];
            ListIterator it=markers.listIterator();

            double v;
            int i,r=0;
            while(it.hasNext())
                {
                    v=val2ScreenCoords( ((Double)it.next()).doubleValue() );
                    for(i=0;i<xp.length;i++)
                        {
                            xPoints[i]=xp[i]+(int)v;
                            yPoints[i]=yp[i]+deltay2;
                        }

                    if(r==highlight)
                        {
                            g.setColor(c3);
                            g.fillPolygon(xPoints,yPoints,5);
                        }
                    else
                        {
                            g.setColor(c);
                            g.fillPolygon(xPoints,yPoints,5);
                        }

                    g.setColor(c2);

                    g.drawLine(xPoints[2],yPoints[2],xPoints[3],yPoints[3]);
                    g.drawLine(xPoints[3],yPoints[3],xPoints[4],yPoints[4]);
                    g.drawLine(xPoints[4],yPoints[4],xPoints[0],yPoints[0]);
                    g.setColor(c1);
                    g.drawLine(xPoints[0],yPoints[0],xPoints[1],yPoints[1]);
                    g.drawLine(xPoints[1],yPoints[1],xPoints[2],yPoints[2]);


                    r++;
                }
        }

        public double val2ScreenCoords(double x)
        {
            return (x-min)*((double)width-spaceLeft-spaceRight-1.0)/(max-min)+spaceLeft;
        }

        public double screen2ValCoords(double x)
        {
            return min+(x-spaceLeft)*(max-min)/(width-1-spaceLeft-spaceRight);
        }

        protected boolean insideMarker(int x,int y,int v)
        {
            x=x-v;
            y=y-deltay2;
            boolean b=true;
            int l=xp.length;
            int i;
            for(i=0;i<l;i++)
                {
                    b=b&&(((xp[(i+1)%l]-xp[i])*(y-yp[i])-(yp[(i+1)%l]-yp[i])*(x-xp[i])) <0);
                }
            return b;
            /*int pv2=((xp[2]-xp[1])*(y-yp[1])-(yp[2]-yp[1])*(x-xp[1]));
            int pv3=((xp[0]-xp[2])*(y-yp[2])-(yp[0]-yp[2])*(x-xp[2]));
            return ((pv1<0)&&(pv2<0)&&(pv3<0));*/
        }


        public int getMarkerNum(int x,int y)
        {
            ListIterator it=markers.listIterator(markers.size());
            double v;
            int r;
            r=markers.size()-1;

            while(it.hasPrevious())
                {
                    v=val2ScreenCoords( ((Double)it.previous()).doubleValue() );
                    if(insideMarker(x,y,(int)v))
                        return r;
                    r--;
                }
            return -1;
        }

        public void mouseClicked(MouseEvent e)
    {}

        public void mouseEntered(MouseEvent e)
        {}

        public void mouseExited(MouseEvent e)
        {
            if(highlight!=-1)
                {
                    highlight=-1;
                }
            if((selected!=-1)&&RemoveWhenDragOut)
                {
                    removeMarker(selected);
                    selected=-1;
                }
            repaint();
        }

        public void mousePressed(MouseEvent e)
        {
            if((e.getModifiers()&MouseEvent.BUTTON1_MASK)!=0)
                {
                    selected=getMarkerNum(e.getX(),e.getY());
                    if(selected!=-1)
                        notifyBeginMarkerMove(selected);
                    if(selected==-1)
                        {
                            addMarker(screen2ValCoords(e.getX()) );
                        }
                }
        }

        public void mouseReleased(MouseEvent e)
        {
            if(selected!=-1)
                notifyEndMarkerMove(selected);
            selected=-1;
        }

        public void mouseMoved(MouseEvent e)
        {
            int n=getMarkerNum(e.getX(),e.getY());
            if(n!=highlight)
                {
                    highlight=n;
                    repaint();
                }
            highlight=n;
        }

        public void mouseDragged(MouseEvent e)
        {
            double x,v;

            if(selected>=0)
                {
                    Dimension d=getSize();
                    x=Math.min(Math.max(e.getX(),spaceLeft),(double)d.width-1-spaceRight);
                    v=screen2ValCoords(x);

                    moveMarker(selected,v);
                }
        }

        public void componentHidden(ComponentEvent e)
        {}

        public void componentMoved(ComponentEvent e)
        {}

        public void componentResized(ComponentEvent e)
        {
            Dimension d=getSize();
            width=d.width;
            height=d.height;

            removeAll();
            double n=Math.ceil( Math.log( 2.0*(max-min)/(width-spaceLeft-spaceRight-1) )/Math.log(10.0) );

            double delta=Math.pow(10.0,n);

            double xmin=Math.ceil(min/delta)*delta;
            double xmax=Math.floor(max/delta)*delta;

            double x;
            int xi,x2;
            int xa=0;

            double xx=0,xx2=0;
            int m=(int)Math.round( xmin/delta );
            m= ((m%10)+10)%10;
            boolean first=true;
            Dimension dim=null;
            for(x=xmin;x<=xmax+delta/10;x+=delta)
                {
                    xi=(int)Math.round(val2ScreenCoords(x));

                    if( m ==0)
                        {
                            if(first)
                                {
                                    xx=x;
                                    first=false;
                                }
                            xx2=x;
                        }
                    m++;
                    m=m%10;
                }


            JLabel label=new JLabel(format.format(xx));
            dim=label.getPreferredSize();
            spaceLeft=dim.width/2+1;

            label=new JLabel(format.format(xx2));
            dim=label.getPreferredSize();

            spaceRight=dim.width/2+1;

            // second
            n=Math.ceil( Math.log( 2.0*(max-min)/(width-spaceLeft-spaceRight-1) )/Math.log(10.0) );

            delta=Math.pow(10.0,n);

            xmin=Math.ceil(min/delta)*delta;
            xmax=Math.floor(max/delta)*delta;

            m=(int)Math.round( xmin/delta );
            m= ((m%10)+10)%10;
            int lastx=-1000000;

            for(x=xmin;x<=xmax+delta/10;x+=delta)
                {
                    xi=(int)Math.round(val2ScreenCoords(x));

                    if( m ==0)
                        {
                            int h=font.getSize();

                            label=new JLabel(format.format(x));
                            //add(label);
                            dim=label.getPreferredSize();

                            x2=xi-dim.width/2;
                            label.setLocation(x2, 0);
                            label.setSize(label.getPreferredSize());
                            if(x2>lastx)
                                {
                                    add(label);
                                    lastx=x2+dim.width+3;
                                }
                        }

                    m++;
                    m=m%10;
                }
        }

        public void componentShown(ComponentEvent e)
        {}

        protected Vector markers;
        protected boolean marksSorted;
        protected Vector listeners;
        protected ChangeEvent changeEvent;
        protected int[] xp;
        protected int[] yp;
        protected int selected,highlight;
        protected Color c,c1,c2,c3;

        double min,max;
        int width,height;
        int labelsHeight;
        int deltay1,deltay2;
        int gradHeight1,gradHeight2,gradHeight3;
        int spaceLeft,spaceRight;
        Font font;
        DecimalFormat format;
        boolean RemoveWhenDragOut;
    }


