/** Contient un ensemble de points de calibration
 * 
 * @author HEIT Sylvestre & Coustillac Laurent
 *
 *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;

import java.util.*;
import java.io.*;

class PointCalibrationSet
    {
        public PointCalibrationSet()
        {
            pointCalibrationList=new Vector();
            listeners=new Vector();
            listeners2=new Vector();
        }

        public void write(DataOutputStream dos) throws IOException
            {
                dos.writeInt(pointCalibrationList.size());
                ListIterator it=pointCalibrationList.listIterator();
                while(it.hasNext())
                    {
                        ((PointCalibrationModel)it.next()).write(dos);
                    }

            }

        public void write2(BufferedWriter dos) throws IOException
            {
                dos.write("nombre="+pointCalibrationList.size());
                dos.newLine();
                ListIterator it=pointCalibrationList.listIterator();
                int i=0;
                while(it.hasNext())
                    {
                        dos.write("point"+i+"=");
                        ((PointCalibrationModel)it.next()).write2(dos);
                        dos.newLine();
                        i++;
                    }

            }


        public void read(DataInputStream dis) throws IOException
            {
                int size=dis.readInt();
                int i;
                pointCalibrationList.clear();
                for(i=0;i<size;i++)
                    {
                        PointCalibrationModel p=new PointCalibrationModel();
                        p.read(dis);
                        add(p);
                    }

            }

        public int size()
        {
            return pointCalibrationList.size();
        }

        public boolean add(PointCalibrationModel p)
        {
            boolean b=pointCalibrationList.add(p);
            p.setPointCalibrationSet(this);
            notifyAdded(p);
            return b;
        }

        public boolean remove(PointCalibrationModel p)
        {
            boolean b=pointCalibrationList.remove(p);
            notifyRemoved(p);
            if(selected==p)
                select(null);
            return b;
        }

        public ListIterator listIterator()
        {
            return new MyListIterator(pointCalibrationList.listIterator());
        }

        public void addSetListener(PointCalibrationSetListener l)
        {
            listeners.add(l);
        }

        public void removeSetListener(PointCalibrationSetListener l)
        {
            listeners.remove(l);
        }

        public void clearSetListener(PointCalibrationSetListener l)
        {
            listeners.clear();
        }

        public void notifyAdded(PointCalibrationModel p)
        {
            ListIterator it=listeners.listIterator();
            while(it.hasNext())
                {
                    ((PointCalibrationSetListener)it.next()).pointCalibrationAdded(p);
                }
        }

        public void notifyRemoved(PointCalibrationModel p)
        {
            ListIterator it=listeners.listIterator();
            while(it.hasNext())
                {
                    ((PointCalibrationSetListener)it.next()).pointCalibrationRemoved(p);
                }
        }



        public void addSelectListener(PointCalibrationSelectListener l)
        {
            listeners2.add(l);
        }

        public void removeSelectListener(PointCalibrationSelectListener l)
        {
            listeners2.remove(l);
        }

        public void clearSelectListener(PointCalibrationSelectListener l)
        {
            listeners2.clear();
        }

        public void notifySelected(PointCalibrationModel p)
        {
            ListIterator it=listeners2.listIterator();
            while(it.hasNext())
                {
                    ((PointCalibrationSelectListener)it.next()).pointCalibrationSelected(p);
                }
        }

        public void select(PointCalibrationModel p)
        {
            if(selected!=p)
                {
                    if(selected!=null)
                        selected.pointCalibrationSelected(p);
                    selected=p;
                    notifySelected(selected);
                    if(selected!=null)
                        selected.pointCalibrationSelected(p);
                }
        }


        public PointCalibrationModel getSelected()
        {
            return selected;
        }


        /* iterateur qui interdit les modifications (on ne veut pas qu'il y ait de modification sans que la modification soit
        notifie)
        */
        class MyListIterator implements ListIterator
            {
                MyListIterator(ListIterator it)
                {
                    iterator=it;
                }

                public void add(Object o)
                {}

                public  boolean hasNext()
                {
                    return iterator.hasNext();
                }

                public  boolean hasPrevious()
                {
                    return iterator.hasPrevious();
                }

                public Object next()
                {
                    return iterator.next();
                }

                public  int nextIndex()
                {
                    return iterator.nextIndex();
                }

                public  Object previous()
                {
                    return iterator.previous();
                }

                public  int previousIndex()
                {
                    return iterator.previousIndex();
                }

                public  void remove()
                {}

                public  void set(Object o)
                {}

                private ListIterator iterator;
            };

        PointCalibrationModel selected;
        protected Vector listeners,listeners2;
        protected Vector pointCalibrationList;
    };
