/**
 * @author Jean BRESSON
 *
 * Programme kartoMNT v2.0
 * Copyright (C) 2003 Roland DERHI & Jean BRESSON
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;

import java.util.*;
import java.io.*;

public class ResourceManager {
	
	
	/** Locale actuelle */
	public static Locale currentLocale;	
	
	public static ResourceBundle myResources;	
	public static Properties myProps;
	
	
	public static void init(){
		
		myProps = new Properties();
		String lang = "";
		try{
		    FileInputStream in = new FileInputStream("karto.ini");
		    myProps.load(in);
	   		in.close();
	   		lang = myProps.getProperty("language");
	   		setLocale(new Locale(lang));
		}
		catch (FileNotFoundException ioe){
		    System.err.println("Fichier karto.ini introuvable !");
		    setLocale(Locale.getDefault());
		}
		catch (Exception e){
		    setLocale(Locale.getDefault());
		}
		
	} 
	
	
	public static void setLocale(Locale loc){
  		
  		currentLocale = loc;	
  		
		try{
			
			myResources = ResourceBundle.getBundle("KartoMNTResources", currentLocale);
			
		} catch(MissingResourceException mre) {
			System.out.println("missing resource exception:");
			System.out.println(mre.getClassName());
		}
	}
	
	
	public static String get(String s){	
		return myResources.getString(s);
	}
	
	
}