/** Outil permettant de definir l'altitude d'une seule ligne de niveau
 * 
 * @author HEIT Sylvestre & Coustillac Laurent
 
 *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;

import java.awt.event.*;
import java.awt.*;
import java.awt.Toolkit;


class ToolAltitude extends ToolGenericDraw implements Tool,MouseListener,MouseMotionListener
    {


        ToolAltitude()
        {
            super();

            cursor=Toolkit.getDefaultToolkit().getImage("icones/cursorbrush.gif");

        }

        //public void setAltitude(float c) {altitude=c;}

        public void attach(DocumentKarto doc)
        {
            detach();
            if(doc!=null)
                {
                    document=doc;
                    lignesDeNiveauxPanel=doc.getFloatDataViewer();
                    lignesDeNiveaux=doc.getLignesDeNiveaux();
                    lignesDeNiveauxPanel.addMouseListener(this);
                    lignesDeNiveauxPanel.addMouseMotionListener(this);

                    Util.setCursor(document.layeredPane,cursor,6,6);

                    lignesDeNiveauxPanel.setBrush(brush);
                    lignesDeNiveaux.setBrush(brush);
                }
        }

        public void setBrush(Brush b)
        {
            brush=b;
        }

        protected void detach()
        {
            if(lignesDeNiveauxPanel!=null)
                {
                    lignesDeNiveauxPanel.setSpecialColor(2,LignesDeNiveaux.TEMP);
                    lignesDeNiveauxPanel.removeMouseListener(this);
                    lignesDeNiveauxPanel.removeMouseMotionListener(this);
                    Util.removeCursor(document.layeredPane);
                }
        }





        public void mouseClicked(MouseEvent e)
        {
            Brush brush=lignesDeNiveaux.getBrush();
            setAltitude(brush,e.getX(),e.getY(),brush.altitude);
            lignesDeNiveauxPanel.setSpecialColor(2,brush.altitude);
        }

        public void mouseEntered(MouseEvent e)
        {}

        public void mouseExited(MouseEvent e)
        {
            lignesDeNiveauxPanel.cleanTemp();
        }

        public void mousePressed(MouseEvent e)
        {}

        public void mouseReleased(MouseEvent e)
        {}


        public void mouseMoved(MouseEvent e)
        {
            lignesDeNiveauxPanel.cleanTemp();
            lignesDeNiveauxPanel.drawTempPoint(e.getX(),e.getY(),LignesDeNiveaux.LINE_WITH_NO_ALTITUDE);
        }


        public void mouseDragged(MouseEvent e)
        {

            lignesDeNiveauxPanel.cleanTemp();
            lignesDeNiveauxPanel.drawTempPoint(e.getX(),e.getY(),LignesDeNiveaux.LINE_WITH_NO_ALTITUDE);

            Brush brush=lignesDeNiveaux.getBrush();
            setAltitude(brush,e.getX(),e.getY(),brush.altitude);
        }



        protected Image cursor;

        protected Brush brush;
        //protected ToolkitKarto toolkit;
    }

