/** Outil permettant de dessiner sur le calque des lignes de niveaux  la souris
 * 
 * @author HEIT Sylvestre & Coustillac Laurent
 
 *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;

import java.awt.event.*;
import java.awt.*;
import java.awt.Toolkit;


class ToolBrush extends ToolGenericDraw implements Tool,MouseListener,MouseMotionListener
    {


        ToolBrush()
        {
            super();

            cursor=Toolkit.getDefaultToolkit().getImage("icones/cursorbrush.gif");
            diffuseAltitude=false;
        }

        public static final int CenterCursorX=6;
        public static final int CenterCursorY=6;

        public void attach(DocumentKarto doc)
        {
            detach();
            if(doc!=null)
                {
                    document=doc;
                    lignesDeNiveauxPanel=doc.getFloatDataViewer();
                    lignesDeNiveaux=doc.getLignesDeNiveaux();
                    /*lignesDeNiveauxPanel.addMouseListener(this);
                    lignesDeNiveauxPanel.addMouseMotionListener(this);*/
                    document.layeredPane.addMouseListener(this);
                    document.layeredPane.addMouseMotionListener(this);

                    lignesDeNiveauxPanel.setSpecialColor(2,LignesDeNiveaux.TEMP);
                    Util.setCursor(document.layeredPane,cursor,CenterCursorX,CenterCursorY);
                    lignesDeNiveaux.setBrush(currentBrush);
                    lignesDeNiveauxPanel.setBrush(currentBrush);
                }

        }

        protected void detach()
        {
            if(lignesDeNiveauxPanel!=null)
                {
                    /*lignesDeNiveauxPanel.removeMouseListener(this);
                    lignesDeNiveauxPanel.removeMouseMotionListener(this);*/
                    document.layeredPane.removeMouseListener(this);
                    document.layeredPane.removeMouseMotionListener(this);
                    lignesDeNiveauxPanel.setSpecialColor(2,LignesDeNiveaux.TEMP);
                    Util.removeCursor(document.layeredPane);
                }
        }


        public void setDiffuseAltitude(boolean b)
        {
            diffuseAltitude=b;
        }

        public void mouseClicked(MouseEvent e)
        {}

        public void mouseEntered(MouseEvent e)
        {}

        public void mouseExited(MouseEvent e)
        {
            lignesDeNiveauxPanel.cleanTemp();
        }

        public void mousePressed(MouseEvent e)
        {
            lastx=e.getX();
            lasty=e.getY();

            if(diffuseAltitude)
                {
                    currentAltitude=getValue(currentBrush,lastx,lasty);
                    if(currentAltitude!=LignesDeNiveaux.EMPTY)
                        {
                            currentBrush.altitude=currentAltitude;
                            //lignesDeNiveauxPanel.setSpecialColor(2,currentAltitude);
                            if( lignesDeNiveaux.isAltitude(currentAltitude))
                                {
                                    lignesDeNiveauxPanel.setSpecialColor(2,currentAltitude);
                                }
                            else
                                {
                                    lignesDeNiveauxPanel.setSpecialColor(2,LignesDeNiveaux.TEMP);
                                }
                        }
                    else
                        {
                            currentAltitude=LignesDeNiveaux.EMPTY;
                            currentBrush.altitude=LignesDeNiveaux.EMPTY;
                            lignesDeNiveauxPanel.setSpecialColor(2,LignesDeNiveaux.TEMP);
                        }
                }

            lignesDeNiveauxPanel.drawLine(lignesDeNiveaux,e.getX(),e.getY(),e.getX(),e.getY());

            if(diffuseAltitude)
                {
                    //setAltitude(lastx,lasty,currentAltitude);
                    setAltitude(currentBrush,e.getX(),e.getY(),currentAltitude);
                }
        }




        /*protected void setAltitude (int x, int y, float value)
        {
            lignesDeNiveaux.setAltitude((int)lignesDeNiveauxPanel.canvas2ObjX(x),(int)lignesDeNiveauxPanel.canvas2ObjX(y),value);
    }*/


        public void mouseReleased(MouseEvent e)
        {
            lignesDeNiveauxPanel.cleanTemp();
        }


        public void mouseMoved(MouseEvent e)
        {
            updateCursor(lignesDeNiveauxPanel,e.getX(),e.getY(),cursor,CenterCursorX,CenterCursorY);

            /*Dimension dim=lignesDeNiveauxPanel.getSize();
            boolean b=(e.getX()>=dim.width) || (e.getY()>=dim.height);
            if(b &&(!out))
                {out=true;
                 Util.removeCursor(document.layeredPane);
                }

            if(!b &&(out))
                {out=false;
                 Util.setCursor(document.layeredPane,cursor,CenterCursorX,CenterCursorY);
                }
            */

            lignesDeNiveauxPanel.cleanTemp();
            lignesDeNiveauxPanel.drawTempPoint(e.getX(),e.getY(),LignesDeNiveaux.LINE_WITH_NO_ALTITUDE);
        }

        public void mouseDragged(MouseEvent e)
        {
            if((diffuseAltitude)&&(currentAltitude!=LignesDeNiveaux.EMPTY)&&
            	( currentAltitude != LignesDeNiveaux.LINE_WITH_NO_ALTITUDE))
                {
                    currentBrush.altitude=LignesDeNiveaux.TEMP;
                    lignesDeNiveauxPanel.drawLine(lignesDeNiveaux,lastx,lasty,e.getX(),e.getY());
                    //setAltitude(e.getX(),e.getY(),currentAltitude);
                    setAltitude(currentBrush,e.getX(),e.getY(),currentAltitude);
                }
            else
                {
                    lignesDeNiveauxPanel.drawLine(lignesDeNiveaux,lastx,lasty,e.getX(),e.getY());
                }

            lastx=e.getX();
            lasty=e.getY();

            lignesDeNiveauxPanel.cleanTemp();
            lignesDeNiveauxPanel.drawTempPoint(lastx,lasty,LignesDeNiveaux.LINE_WITH_NO_ALTITUDE);
        }

        protected int lastx,lasty;
        protected boolean diffuseAltitude;
        protected float currentAltitude;
        protected Image cursor;

    }

