/** Outil permettant d'estimer l'altitude en un point
 * 
 * @author HEIT Sylvestre & Coustillac Laurent
  *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;


import java.awt.event.*;
import java.awt.*;
import java.awt.Toolkit;
import java.text.*;

class ToolGetAltitude implements Tool,MouseListener
    {

        ToolGetAltitude(BarreEtat b)
        {
            super();
            barre=b;
            format=new DecimalFormat("#.##");
        }


        public void attach(DocumentKarto doc)
        {
            detach();
            if(doc!=null)
                {
                    document=doc;
                    lignesDeNiveauxPanel=doc.getFloatDataViewer();
                    lignesDeNiveaux=doc.getLignesDeNiveaux();
                    //lignesDeNiveauxPanel.addMouseListener(this);
                    document.layeredPane.addMouseListener(this);

                    lignesDeNiveauxPanel.setSpecialColor(2,LignesDeNiveaux.TEMP);

                }

        }

        protected void detach()
        {
            if(lignesDeNiveauxPanel!=null)
                {
                    //lignesDeNiveauxPanel.removeMouseListener(this);
                    document.layeredPane.addMouseListener(this);
                    lignesDeNiveauxPanel.setSpecialColor(2,LignesDeNiveaux.TEMP);
                    Util.removeCursor(document.layeredPane);
                }
        }



        public void mouseClicked(MouseEvent e)
        {}

        public void mouseEntered(MouseEvent e)
        {}

        public void mouseExited(MouseEvent e)
        {}

        public void mousePressed(MouseEvent e)
        {
            int x=(int)(e.getX()/lignesDeNiveauxPanel.getScaleX());
            int y=(int)(e.getY()/lignesDeNiveauxPanel.getScaleX());

            float val=lignesDeNiveaux.interpolePoint(x,y);

            if( lignesDeNiveaux.isAltitude(lignesDeNiveaux.getValue(x,y)) )
                {
                    lignesDeNiveauxPanel.setSpecialColor(2,val);
                }
            else
                {
                    lignesDeNiveauxPanel.setSpecialColor(2,LignesDeNiveaux.TEMP);
                }


            if(lignesDeNiveaux.isAltitude(val))
                {
                    barre.setMessage(ResourceManager.get("altEstim")+" = "+format.format(val));
                }
            else
                {
                    barre.setMessage("");
                }

        }

        public void mouseReleased(MouseEvent e)
        {
            lignesDeNiveauxPanel.cleanTemp();
        }


        BarreEtat barre;
        DocumentKarto document;
        FloatDataViewer lignesDeNiveauxPanel;
        LignesDeNiveaux lignesDeNiveaux;
        DecimalFormat format;
    }

