/** Outil permettant de tracer un ligne sur le calque des lignes de niveaux  la souris
 * 
 * @author HEIT Sylvestre & Coustillac Laurent
  *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;

import java.awt.event.*;
import java.awt.*;
import java.awt.Toolkit;


class ToolLine extends ToolGenericDraw implements Tool,MouseListener,MouseMotionListener
    {


        ToolLine()
        {
            super();
            cursor=Toolkit.getDefaultToolkit().getImage("icones/cursorbrush.gif");
            //toolkit=tk;
            line=new Line();
            diffuseAltitude=false;
        }

        public static final int CenterCursorX=6;
        public static final int CenterCursorY=6;


        public void attach(DocumentKarto doc)
        {
            detach();
            if(doc!=null)
                {
                    document=doc;
                    lignesDeNiveauxPanel=doc.getFloatDataViewer();
                    lignesDeNiveaux=doc.getLignesDeNiveaux();
                    document.layeredPane.addMouseListener(this);
                    document.layeredPane.addMouseMotionListener(this);
                    lignesDeNiveauxPanel.setSpecialColor(2,LignesDeNiveaux.TEMP);
                    Util.setCursor(document.layeredPane,cursor,CenterCursorX,CenterCursorX);
                    lignesDeNiveaux.setBrush(currentBrush);
                    lignesDeNiveauxPanel.setBrush(currentBrush);
                }

        }

        protected void detach()
        {
            if(lignesDeNiveauxPanel!=null)
                {
                    document.layeredPane.removeMouseListener(this);
                    document.layeredPane.removeMouseMotionListener(this);
                    lignesDeNiveauxPanel.setSpecialColor(2,LignesDeNiveaux.TEMP);
                    Util.removeCursor(document.layeredPane);
                }
        }


        public void setDiffuseAltitude(boolean b)
        {
            diffuseAltitude=b;
        }


        public void mouseClicked(MouseEvent e)
        {}

        public void mouseEntered(MouseEvent e)
        {}

        public void mouseExited(MouseEvent e)
        {
            lignesDeNiveauxPanel.cleanTemp();
        }

        public void mousePressed(MouseEvent e)
        {
            lastx=e.getX();
            lasty=e.getY();

            if(diffuseAltitude)
                {
                    currentAltitude=getValue(currentBrush,lastx,lasty);
                    if(/*(currentAltitude!=LignesDeNiveaux.LINE_WITH_NO_ALTITUDE) &&*/(currentAltitude!=LignesDeNiveaux.EMPTY))
                        {
                            currentBrush.altitude=currentAltitude;
                            //lignesDeNiveauxPanel.setSpecialColor(2,currentAltitude);
                            if( lignesDeNiveaux.isAltitude(currentAltitude))
                                {
                                    lignesDeNiveauxPanel.setSpecialColor(2,currentAltitude);
                                }
                            else
                                {
                                    lignesDeNiveauxPanel.setSpecialColor(2,LignesDeNiveaux.TEMP);
                                }
                        }
                    else
                        {
                            currentAltitude=LignesDeNiveaux.LINE_WITH_NO_ALTITUDE;
                            currentBrush.altitude=LignesDeNiveaux.LINE_WITH_NO_ALTITUDE;
                            lignesDeNiveauxPanel.setSpecialColor(2,LignesDeNiveaux.TEMP);
                        }
                }

            lignesDeNiveauxPanel.drawTempLine(e.getX(),e.getY(),e.getX(),e.getY());


        }

        public void mouseReleased(MouseEvent e)
        {
            lignesDeNiveauxPanel.cleanTemp();

            if((diffuseAltitude)&&(currentAltitude!=LignesDeNiveaux.EMPTY)){
            	currentBrush.altitude=LignesDeNiveaux.TEMP;
                lignesDeNiveauxPanel.drawLine(lignesDeNiveaux,lastx,lasty,e.getX(),e.getY());
                // ne pas propager une altitude non dfinit
            	if ( currentAltitude != LignesDeNiveaux.LINE_WITH_NO_ALTITUDE){
                    setAltitude(currentBrush,e.getX(),e.getY(),currentAltitude);
                } else if ((getValue(currentBrush,e.getX(),e.getY())!= LignesDeNiveaux.LINE_WITH_NO_ALTITUDE)
                		&&(getValue(currentBrush,e.getX(),e.getY())!=LignesDeNiveaux.EMPTY)){
                	setAltitude(currentBrush,lastx,lasty,getValue(currentBrush,e.getX(),e.getY()));
                }
            }else{
            	lignesDeNiveauxPanel.drawLine(lignesDeNiveaux,lastx,lasty,e.getX(),e.getY());
            }

            lastx=e.getX();
            lasty=e.getY();

        }

        public void mouseMoved(MouseEvent e)
        {
            updateCursor(lignesDeNiveauxPanel,e.getX(),e.getY(),cursor,CenterCursorX,CenterCursorY);
            lignesDeNiveauxPanel.cleanTemp();
            lignesDeNiveauxPanel.drawTempPoint(e.getX(),e.getY(),LignesDeNiveaux.LINE_WITH_NO_ALTITUDE);
        }


        public void mouseDragged(MouseEvent e)
        {
            lignesDeNiveauxPanel.cleanTemp();
            lignesDeNiveauxPanel.drawTempLine(lastx,lasty,e.getX(),e.getY());
        }


        protected int lastx,lasty;
        protected boolean diffuseAltitude;
        float currentAltitude;
        protected Image cursor;
        Line line;
    }

