/** Outil de selection  la souris d'une couleur RGB sur la carte
 * 
 * @author HEIT Sylvestre & Coustillac Laurent
 *
 * Programme kartoMNT : gnration de MNT  partir d'une carte de lignes de niveaux
 * Copyright (C) 2002  HEIT Sylvestre & Coustillac Laurent
 * 
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
 *Publique Gnrale GNU publie par la Free Software Foundation (version 2).
 *
 *Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
 *y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
 *Licence Publique Gnrale GNU pour plus de dtails.
 *
 *Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ; si
 *ce n'est pas le cas, crivez  la
 *Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 */
package kartoMNT;


import java.awt.event.*;
import java.util.*;
import java.awt.*;
import java.awt.Toolkit;


class ToolSelectColor implements Tool,MouseListener
    {

        ToolSelectColor()
        {

            colorListener=new Vector();
            icursor=Toolkit.getDefaultToolkit().getImage("icones/cursorselectcolor.gif");

        }

        public void attach(DocumentKarto doc)
        {
            detach();
            if(doc!=null)
                {
                    document=doc;
                    imageCanvas=doc.getCarteCanvas();
                    //imageCanvas.addMouseListener(this);
                    document.layeredPane.addMouseListener(this);

                    Util.setCursor(document.layeredPane,icursor,12,24);
                }
        }

        protected void detach()
        {
            if(imageCanvas!=null)
                {
                    //imageCanvas.removeMouseListener(this);
                    document.layeredPane.addMouseListener(this);

                    Util.removeCursor(document.layeredPane);
                }
        }


        public void addColorListener(ColorListener l)
        {
            colorListener.add(l);
        }

        public void removeColorListener(ColorListener l)
        {
            colorListener.remove(l);
        }

        public void clearColorListeners()
        {
            colorListener.clear();
        }


        public void DispatchColorEvent(Color c)
        {
            if(c==null)
                return;
            for(int i=0;i<colorListener.size();i++ )
                {
                    ((ColorListener)(colorListener.elementAt(i))).colorSelected(c);
                }
        }

        protected Vector colorListener;


        public void mouseClicked(MouseEvent e)
        {}

        public void mouseEntered(MouseEvent e)
        {}

        public void mouseExited(MouseEvent e)
        {}

        public void mousePressed(MouseEvent e)
        {
            DispatchColorEvent(imageCanvas.getColor(e.getX(),e.getY()));
        }

        public void mouseReleased(MouseEvent e)
        {}




        protected ImageCanvas imageCanvas;
        protected DocumentKarto document;
        protected Image icursor;
    }
