package kartoMNT.visu3d;


import javax.vecmath.*;
import javax.media.j3d.*;

/**
 * * KartoMNT V2 <BR>
 * Une simple croix verte
 */
class Crosshair extends Shape3D
{
	/** Table des lignes composant la croix */
	private LineArray crosshairGeometry = new LineArray(4, GeometryArray.COORDINATES | GeometryArray.COLOR_3);

  /**
   * Constructeur
   * @param z Distance en z  laquelle sera affiche la croix
   * @param size Taille de la croix
   */
	public Crosshair(float z, float size)
	{
		super();
		
		Point3f verts[] = new Point3f[4];
        Color3f colors[] = new Color3f[4];
		verts[0] = new Point3f(0.0f,  size, z);
		verts[1] = new Point3f(0.0f, -size, z);
		verts[2] = new Point3f(size,  0.0f, z);
		verts[3] = new Point3f(-size, 0.0f, z);
		colors[0] = new Color3f(0.0f, 1.0f, 0.0f);
		colors[1] = new Color3f(0.0f, 1.0f, 0.0f);
		colors[2] = new Color3f(0.0f, 1.0f, 0.0f);
		colors[3] = new Color3f(0.0f, 1.0f, 0.0f);
		crosshairGeometry.setCoordinates(0, verts);
		crosshairGeometry.setColors(0, colors);
		this.setGeometry(crosshairGeometry);
	}
}
