/*
 *	@(#)OffScreenCanvas3D.java 1.4 00/02/10 13:14:24
 *
 * Copyright (c) 1996-2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */
package kartoMNT.visu3d;

import java.awt.*;
import java.awt.image.BufferedImage;
import java.awt.event.*;
import javax.media.j3d.*;
import javax.vecmath.*;

/**
 * Canvas Off-Screen pour crer les captures d'cran hautes qualits
*/
class OffScreenCanvas3D extends Canvas3D {

  
  boolean printing = false;

    /**
     * Constructeur
     *@param gconfig configuration du canvas 3D
     *@param offscreenflag  true pour canvas offcreen
    */
  public OffScreenCanvas3D(GraphicsConfiguration gconfig, boolean offscreenflag) {

    super(gconfig, offscreenflag);
    
  }

    /**
     * Rendu d'une image de haute-qualit
     * @return l'image calcule
    */
  public BufferedImage retourneImage() {

      // initialisation de l'image
    BufferedImage bImage = new BufferedImage(
                                Variables.qualCaptW, Variables.qualCaptH , BufferedImage.TYPE_INT_RGB);

    ImageComponent2D buffer = new ImageComponent2D(
                                ImageComponent.FORMAT_RGB, bImage);
    buffer.setCapability(ImageComponent2D.ALLOW_IMAGE_READ);

    this.setOffScreenBuffer(buffer);
    // rendu de l'image
    this.renderOffScreenBuffer();
    this.waitForOffScreenRendering();
    return drawOffScreenBuffer();

  }
  
    /**
     * Retoune l'image rendu off-screen
     * @return l'image rendu off-screen
    */
  public BufferedImage drawOffScreenBuffer() {      

      BufferedImage bImage = this.getOffScreenBuffer().getImage();
      
      return bImage;
  }
}

