package kartoMNT.visu3d;

import java.awt.*;
import java.awt.image.*;
import javax.swing.*;
import java.util.*;
import java.io.*;
import javax.media.j3d.*;
import javax.media.j3d.Raster; 
import com.sun.image.codec.jpeg.*;

import kartoMNT.*;
import kartoMNT.visu3d.gif.*;

/**
 * <P>
 * KartoMNT V2 <BR>
 * Thread de capture de squence d'images et de film au format gif<BR>
 * <BR>
 * Ralis sous la direction de LINGRAND Diane et FERNANDES Gilbert <BR>
 * Ecole Suprieure en Sciences Informatiques de Sophia-Antipolis (FRANCE)
 * </P>
 *
 * @author DERHI Roland
 * 
 */
 public class Sequenceur implements Runnable{
	/** ArrayList o se trouve la squence d'images captures */
	private ArrayList listeImages=new ArrayList();
	/** la thread */
    Thread thread;
    /** la thread est-elle arrte */
    private boolean threadSuspended=false;
    /** Panel o on effectue les captures */
	private Canvas3D canvas;
	/** Numro de squences */
	static private int sequence=0;
	/** Numro de film */
	static private int numfilm=0;
	/** Doit-on continuer la saisie ? */
	private boolean continu=true;
	/** Encodeur gif */
	private AnimatedGifEncoder gifEnc;	
	/** Classe permettant de sauvegarder en JPEG */
	private JPEGImageEncoder jpe=null;
	/** Robot de saisie des images */
	//private Robot robot;
	/** Temps en millisecondes entre chaque saisie */
	private int tempsEntreFrame;
	/** Si a vrai, on ralise une squence de film, sinon une squence d'images */
	private boolean film;
	/** Le ProgressMonitor de sauvegarde des images saisies */
	private ProgressMonitor progMon;
	/** Indice de sauvegarde des images saisies */
	private int sauvegarde=0;
	/** JFileChooser de capture */
	private static JFileChooser fcSeq=new JFileChooser("./capture/");
	/** JFileChooser de capture */
	private static JFileChooser fcMov=new JFileChooser("./capture/");
	
	static{
		fcSeq.setFileSelectionMode(JFileChooser.FILES_ONLY);
		fcMov.setFileSelectionMode(JFileChooser.FILES_ONLY);
		fcSeq.setAcceptAllFileFilterUsed(false);
		fcMov.setAcceptAllFileFilterUsed(false);

		
		ExampleFileFilter filterImg = new ExampleFileFilter();
		filterImg.addExtension("jpg");		
		filterImg.setDescription(ResourceManager.get("jpgImage"));
		fcSeq.addChoosableFileFilter(filterImg);
		
		ExampleFileFilter filterImg2 = new ExampleFileFilter();
		filterImg2.addExtension("gif");
		filterImg2.setDescription(ResourceManager.get("gifImage"));
		fcSeq.addChoosableFileFilter(filterImg2);
		
		fcMov.addChoosableFileFilter(filterImg2);
	
	}

	/**
	 *	Constructeur
	 * @param f Film ou Squence d'images ?
	 * @param robot Robot de saisie des images
	 * @param gE encodeur d'images gif
	 * @param p panel o s'effectue les captures
	 **/
	public Sequenceur(boolean f,AnimatedGifEncoder gE,Canvas3D p){
		film=f;
		// this.robot=robot;
		canvas=p;
		gifEnc=gE;		
		thread = new Thread(this);
		
		// rpertoire o seront placs les captures d'cran
		File dir = new File("./capture/");
		if (dir == null) {
		    System.err.println("Le rpertoire ./capture/ n'a pas t trouv");	   		 
		}
		else{
			try{
				// on vrifie si, dans le rpertoire capture des squence d'images ou des films
				// ont t pralablement dj pris. Cela afin d'initialiser sequence et numFilm
				// pour ne pas craser les squences et les films dj pris.
				String[] list = dir.list();
		
				for (int i = 0; i < list.length; i++) {	    
			    if (list[i].indexOf('$') == -1 && (list[i].endsWith(".gif")||(list[i].endsWith(".jpg")))) {
			    	String nomImage = list[i].substring(0,list[i].indexOf('.'));
					String numero = nomImage.substring(4);
					int nombre=0;
					try{
						
						if (!film){
							if (nomImage.startsWith("sequ")){
								nombre = Integer.parseInt(numero.substring(0,numero.indexOf('-')));
								if (nombre>sequence){									
									sequence=nombre;
								}
							}	
						}
						else {
							if (nomImage.startsWith("film")){
								nombre = Integer.parseInt(numero);
								if (nombre>numfilm){									
									numfilm=nombre;
								}
							}
						}
	
					}
					catch(NumberFormatException e){}
		   		 }
				}
			}
			catch(NullPointerException e){}
		}
		
		
		
		
		start();
	}
	
	/** Dmarrage du squenceur */
	public void start(){
		String temps =JOptionPane.showInputDialog(ResourceManager.get("enterWaitTime"));
		if (temps.equals("")){
			return;
		}
		try{
			tempsEntreFrame=Integer.parseInt(temps);
		}
		catch(NumberFormatException nfe){						    
			JOptionPane.showMessageDialog(null,ResourceManager.get("badEnteredTime"),ResourceManager.get("error"),JOptionPane.WARNING_MESSAGE);
			return;
		}
		
		thread.start();
		
	}
	
	/** Stoppe la Thread */
    public synchronized void resume() {
		threadSuspended = false;
    	notify();

    }
    
    /** Reprend la Thread */
    public void suspend() {
	threadSuspended =true;

    }

	/**
	 *	Mhode appele lors uu dmarrage de la thread
	 **/
	public void run() {
		Point p;
		Dimension d;

		int nbIm=0;
		
		while(continu){
			// on cherche la position du panel  l'cran
			// p = panelCanvas.getLocationOnScreen();
// 			d = panelCanvas.getSize();
// 			int width = (int)d.getWidth();
// 			int height = (int)d.getHeight();
			
			// on rajoute la capture  la liste des images
			//listeImages.add(robot.createScreenCapture(new Rectangle((int)p.getX(), (int)p.getY(), width, height)));
		    //BufferedImage image = new BufferedImage(canvas.getWidth(),canvas.getHeight(),BufferedImage.TYPE_INT_RGB);
		    //canvas.getGraphics2D().drawAndFlushImage(image,0,0,null);
		    //Canvas3D myCanvas=canvas.getView().getCanvas3D(1);
		    //myCanvas.setOffScreenBuffer(new ImageComponent2D(ImageComponent.FORMAT_RGB,canvas.getWidth(),canvas.getHeight()));
		    //myCanvas.getScreen3D().setSize(canvas.getWidth(),canvas.getHeight()); 
		    //myCanvas.renderOffScreenBuffer();
		    //myCanvas.waitForOffScreenRendering();
		    //BufferedImage image = myCanvas.getOffScreenBuffer().getImage();
		    int width = canvas.getSize().width;
		    int height = canvas.getSize().height;
		    GraphicsContext3D  ctx = canvas.getGraphicsContext3D();
		    Raster ras = new Raster();
		    ras.setType(Raster.RASTER_COLOR);
		    ras.setSize(width, height);
		    ras.setSrcOffset(0, 0);
		    BufferedImage image =
			new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
		    ImageComponent2D image2d =
			new ImageComponent2D(ImageComponent2D.FORMAT_RGB, image);
		    ras.setImage(image2d);

		    ctx.readRaster(ras);

		    // Now strip out the image info
		    ImageComponent2D img_src = ras.getImage();           
      		    	
		    listeImages.add(img_src.getImage());
		
			// on attent un moment avant de recommencer
			try {
			    thread.sleep(tempsEntreFrame);
			    
			    if (threadSuspended) {
					synchronized(this) { while (threadSuspended) wait(); } 
				 }

			} 
			catch(InterruptedException e) {
			    System.out.println("Erreur dans le sleep");
			    e.printStackTrace();
			}
		}
		
		Object[] options=null;
		int value=0;
		
		if (film){
			options = new Object[2];
			options[0]=ResourceManager.get("auto");
			options[1]=ResourceManager.get("manual");
			 value = JOptionPane.showOptionDialog(null,
					     ResourceManager.get("autoName"),
					     ResourceManager.get("question"),
					     JOptionPane.YES_NO_OPTION,
					     JOptionPane.QUESTION_MESSAGE,
					     null,     //don't use a custom Icon
					     options,  //the titles of buttons
					     options[0]); //default button title
		}
		else{
			options = new Object[3];
			options[0]=ResourceManager.get("auto")+" GIF";
			options[1]=ResourceManager.get("auto")+" JPEG";
			options[2]=ResourceManager.get("manual");
			 value = JOptionPane.showOptionDialog(null,
					     ResourceManager.get("autoPrefix"),
					     ResourceManager.get("question"),
					     JOptionPane.YES_NO_CANCEL_OPTION,
					     JOptionPane.QUESTION_MESSAGE,
					     null,     //don't use a custom Icon
					     options,  //the titles of buttons
					     options[0]); //default button title
			
		}
					     
				String nomFichier=null;
				String extensionChoisie=null;
		// on choisit le fichier de sauvegarde       
			  if ((value == JOptionPane.NO_OPTION)){
			  	if (options[1].equals(ResourceManager.get("manual"))){
			  		int returnVal = fcMov.showSaveDialog(null);
					
				
					if (returnVal==JFileChooser.APPROVE_OPTION){
					    File file=fcMov.getSelectedFile();
						// on vrifie si le fichier est accessible
					    if (file.exists()){
							if (!file.canRead()){
							    JOptionPane.showMessageDialog(null,ResourceManager.get("errorFileRead"),ResourceManager.get("error"),JOptionPane.WARNING_MESSAGE);
							    return;
							}
							
						 }
						 nomFichier=file.getPath();
					
						
						if (!nomFichier.endsWith(".gif"))
							nomFichier=nomFichier+".gif";
					
			  		}
			  	}
			  	else{
			  		extensionChoisie="jpg";
			  	}
			  }
		      else if (value == JOptionPane.CANCEL_OPTION) {
			      int returnVal = fcSeq.showSaveDialog(null);;
				
					if (returnVal==JFileChooser.APPROVE_OPTION){
					    File file=fcSeq.getSelectedFile();
						// on vrifie si le fichier est accessible
					    if (file.exists()){
							if (!file.canRead()){
							    JOptionPane.showMessageDialog(null,ResourceManager.get("errorFileRead"),ResourceManager.get("error"),JOptionPane.WARNING_MESSAGE);
							    return;
							}
							
						 }
						 nomFichier=file.getPath();
						extensionChoisie = (String)(((ExampleFileFilter)(fcSeq.getFileFilter())).getExtensions().nextElement());
						
			  		}
			  }
		
		
		
		progMon= new ProgressMonitor(null,ResourceManager.get("saveInProgress"),ResourceManager.get("pleaseWait"),0,listeImages.size());
		progMon.setProgress(sauvegarde);
		progMon.setMillisToPopup(0);

		// on sauvegarde les images saisies
		if (!film){
			int num=0;
			if ((value == JOptionPane.YES_OPTION)||((value == JOptionPane.NO_OPTION)&&(options[1].equals(ResourceManager.get("auto")+" JPEG"))))
	 	     	++sequence;
	 	     	
			for(Iterator it=listeImages.iterator();it.hasNext();){
				++num;
				if (value == JOptionPane.YES_OPTION) {
					
	    		    gifEnc.start("capture/sequ"+sequence+"-"+((num/100)%10)+""+((num/10)%10)+""+(num%10)+".gif");
	   			}
	   			else if ((value == JOptionPane.NO_OPTION)&&(options[1].equals(ResourceManager.get("auto")+" JPEG"))){
	   				try{

	   					jpe = JPEGCodec.createJPEGEncoder(new FileOutputStream("capture/sequ"+sequence+"-"+((num/100)%10)+""+((num/10)%10)+""+(num%10)+".jpg"));

	   				} catch(FileNotFoundException e){
	   					
	   				}
	   			}
	    		else{

	    			if ((extensionChoisie!=null)&&(extensionChoisie.equals("jpg"))){
	    				try{

	    					jpe = JPEGCodec.createJPEGEncoder(new FileOutputStream(nomFichier+"-"+((num/100)%10)+""+((num/10)%10)+""+(num%10)+".jpg"));

	    				} catch(FileNotFoundException e){
	   					
	   					}
	    			}
	    			else{

						gifEnc.start(nomFichier+"-"+((num/100)%10)+""+((num/10)%10)+""+(num%10)+".gif");
					}
				}

				if ((extensionChoisie!=null)&&(extensionChoisie.equals("jpg"))){
					try{
						BufferedImage image = (BufferedImage)it.next();
						JPEGEncodeParam jpeParam = jpe.getDefaultJPEGEncodeParam(image);
						jpeParam.setQuality(1.0f,false);   
				   		jpe.setJPEGEncodeParam(jpeParam);
				   		jpe.encode(image);
				   		OutputStream fich = jpe.getOutputStream();
				   		fich.flush();
				   		fich.close();
				   	}
				   	catch (Exception e){
				   		JOptionPane.showMessageDialog(null,ResourceManager.get("errorCaptJPEG")	,ResourceManager.get("error"),JOptionPane.ERROR_MESSAGE);
				   		return;	
				   	}
				}
				else{
	    	  		gifEnc.addFrame((BufferedImage)it.next());

      			 	gifEnc.finish();
				   
				}
				progMon.setProgress(++sauvegarde);
				progMon.setNote("Image "+sauvegarde+"/"+listeImages.size());
			}
		}
		else{
			if (value == JOptionPane.YES_OPTION) {						
				++numfilm;
				gifEnc.start("capture/film"+((numfilm/100)%10)+""+((numfilm/10)%10)+""+(numfilm%10)+".gif");
			}
			else{
				gifEnc.start(nomFichier);
			}
			
			gifEnc.setDelay(tempsEntreFrame);
			for(Iterator it=listeImages.iterator();it.hasNext();){
	    		gifEnc.addFrame((BufferedImage)it.next());
			    progMon.setProgress(++sauvegarde);
			    progMon.setNote("Image "+sauvegarde+"/"+listeImages.size());
			}
			gifEnc.finish();

		}
		progMon.close();
	}
	
	/**
	 * Arrete la Thread
	 **/
	public void stop(){
		continu=false;
	}
	
	

}
