package kartoMNT.visu3d;


import javax.vecmath.*;
import javax.media.j3d.*;

/**
 * * KartoMNT V2 <BR>
 * Le Socle qui sera affich  la base du LandScape
 */
class Socle extends Shape3D
{
	/** Table des lignes composant le socle */
	private LineArray socleGeometry = new LineArray(16, GeometryArray.COORDINATES | GeometryArray.COLOR_3);

  /**
   * Constructeur
   * @param L Le terrain 3D dont on construit le socle 
   */
	public Socle(LandScape L)
	{
		super();
		
		float xMax= (L.getXSize()-1)*L.getGridScaleX();
		float yMax= (L.getYSize()-1)*L.getGridScaleY();
		
		Point3f verts[] = new Point3f[16];
        Color3f colors[] = new Color3f[16];
		verts[0] = new Point3f(0,  0, 0);
		verts[1] = new Point3f(xMax, 0, 0);
		verts[2] = new Point3f(0,  0, 0);
		verts[3] = new Point3f(0, 0, yMax);
		verts[4] = new Point3f(0,  0, 0);
		verts[5] = new Point3f(0, L.getHeight(0,0)*L.getZScale(), 0);
		verts[6] = new Point3f(xMax,  0, 0);
		verts[7] = new Point3f(xMax,  0, yMax);
		verts[8] = new Point3f(xMax,  0, 0);
		verts[9] = new Point3f(xMax,  L.getHeight(L.getXSize()-1,0)*L.getZScale(), 0);
		verts[10] = new Point3f(0,  0, yMax);
		verts[11] = new Point3f(xMax,  0, yMax);
		verts[12] = new Point3f(0,  0, yMax);
		verts[13] = new Point3f(0,  L.getHeight(0,L.getYSize()-1)*L.getZScale(), yMax);
		verts[14] = new Point3f(xMax,  0, yMax);
		verts[15] = new Point3f(xMax,  L.getHeight(L.getXSize()-1,L.getYSize()-1)*L.getZScale(), yMax);
		
		colors[0] = new Color3f(1.0f, 1.0f, 1.0f);
		colors[1] = new Color3f(1.0f, 1.0f, 1.0f);
		colors[2] = new Color3f(1.0f, 1.0f, 1.0f);
		colors[3] = new Color3f(1.0f, 1.0f, 1.0f);
		colors[4] = new Color3f(1.0f, 1.0f, 1.0f);
		colors[5] = new Color3f(1.0f, 1.0f, 1.0f);
		colors[6] = new Color3f(1.0f, 1.0f, 1.0f);
		colors[7] = new Color3f(1.0f, 1.0f, 1.0f);
		colors[8] = new Color3f(1.0f, 1.0f, 1.0f);
		colors[9] = new Color3f(1.0f, 1.0f, 1.0f);
		colors[10] = new Color3f(1.0f, 1.0f, 1.0f);
		colors[11] = new Color3f(1.0f, 1.0f, 1.0f);
		colors[12] = new Color3f(1.0f, 1.0f, 1.0f);
		colors[13] = new Color3f(1.0f, 1.0f, 1.0f);
		colors[14] = new Color3f(1.0f, 1.0f, 1.0f);
		colors[15] = new Color3f(1.0f, 1.0f, 1.0f);
		
		socleGeometry.setCoordinates(0, verts);
		socleGeometry.setColors(0, colors);
		this.setGeometry(socleGeometry);
	}
}
